/*
   "1stdiffeqn.mm"
   Simulation of the following system:
   dx/dt = -2 x, x(0)=5
*/

Func void main()
{
	Real t0,t1;
	Real h,dtsav;
	Matrix x0,TC,XC,UC;
	void diff_eqs(),link_eqs();

	t0 = 0.0;  //ߥ졼γϻ t=0 ˤ
	t1 = 10.0;  //ߥ졼νλ t=10 ˤ

	x0 = [5.0];  //֤ x(0)=5.0 ˤ

	h = 5.0e-4; // ߥ졼ι0.5msecˤ
	dtsav = 1.0e-3;// ǡ1msec¸

	print "Now simulating\n";

// Ode()ˤäƥߥ졼Ԥ
	{TC, XC, UC} = Ode(t0, t1, x0, diff_eqs, link_eqs, h, dtsav);
// diff_eqs() ʬ򵭽Ҥؿ
// link_eqs() ʣʬδط򵭽Ҥؿ
// TC: ֤λ
// XC: x(t)λ
// UC: ϥ٥ȥλ

//Ͳɽ롥 t, ļ x(t)
	mgplot(1,Array(TC),Array(XC));

	print TC >> "TC.ode";
	print XC >> "XC.ode";
	print UC >> "UC.ode";
}

// diff_eqs() ʬ򵭽Ҥؿ
Func void diff_eqs(DX,t,X,UY)
Real t;
Matrix X,DX,UY;
{
	Matrix xp,up,dxp;

	xp = X; // X x(t)ɽƤ롥

	up = UY; //UYϻѤʤ

	dxp = -2 * xp; //ʬ

	DX = [dxp]; //Ǹ®٤DXϤ
}

// link_eqs() ʣʬδط򵭽Ҥؿ
Func void link_eqs(UY,t,X)
Real t;
Matrix UY,X;
{
	Matrix xp,up;

	xp = X; // X x(t)ɽƤ롥

// ǸUY˻tͤϤȤꤢx(t)򤤤Ƥ
	UY = [xp];

}

